<template>
    <section class="hero is-light is-fullheight">
        <div class="hero-body">
            <div class="container">
                <div class="column is-4 is-offset-4">
                    <h3 class="title has-text-black has-text-centered">Register</h3>
                    <div class="box">
                        <form @submit.prevent="register">
                            <b-field label="First name">
                                <b-input
                                    pattern="[A-zÀ-ÖØ-öø-įĴ-őŔ-žǍ-ǰǴ-ǵǸ-țȞ-ȟȤ-ȳɃɆ-ɏḀ-ẞƀ-ƓƗ-ƚƝ-ơƤ-ƥƫ-ưƲ-ƶẠ-ỿ'\- ]+"
                                    required
                                    ref="first_name"
                                    v-model="first_name"
                                    validation-message="First name may only consist of letters and spaces"
                                ></b-input>
                            </b-field>
                            <b-field label="Middle name (optional)">
                                <b-input
                                    pattern="[A-zÀ-ÖØ-öø-įĴ-őŔ-žǍ-ǰǴ-ǵǸ-țȞ-ȟȤ-ȳɃɆ-ɏḀ-ẞƀ-ƓƗ-ƚƝ-ơƤ-ƥƫ-ưƲ-ƶẠ-ỿ'\- ]*"
                                    ref="middle_name"
                                    v-model="middle_name"
                                    validation-message="Middle name may only consist of letters and spaces"
                                ></b-input>
                            </b-field>
                            <b-field label="Last name">
                                <b-input
                                    required
                                    ref="last_name"
                                    pattern="[A-zÀ-ÖØ-öø-įĴ-őŔ-žǍ-ǰǴ-ǵǸ-țȞ-ȟȤ-ȳɃɆ-ɏḀ-ẞƀ-ƓƗ-ƚƝ-ơƤ-ƥƫ-ưƲ-ƶẠ-ỿ'\- ]+"
                                    validation-message="Last name may only consist of letters and spaces"
                                    v-model="last_name"
                                ></b-input>
                            </b-field>
                            <b-field label="Phone Number">
                                <b-input
                                    required
                                    ref="phone_number"
                                    type="tel"
                                    v-model="phone_number"
                                    maxlength="19"
                                    minlength="10"
                                    pattern="[0-9+ \- \(\)]+"
                                    validation-message="Include country code. For example for US (+1) (555)-555-5555 or UK +44 (0)1234 567890"
                                ></b-input>
                            </b-field>
                            <b-field label="Email">
                                <b-input
                                    required
                                    ref="email"
                                    type="email"
                                    pattern="[a-zA-Z0-9_@\-.]+"
                                    v-model="email"
                                    validation-message="Invalid email address"
                                    placeholder="We'll send a verification to this address"
                                ></b-input>
                            </b-field>
                            <b-field label="Username">
                                <b-input
                                    required
                                    ref="username"
                                    v-model="username"
                                    maxlength="20"
                                    pattern="[a-zA-Z0-9_]+"
                                    validation-message="Username may only consist of letters, underscores, and numbers"
                                ></b-input>
                            </b-field>
                            <b-field
                                label="Password"
                                :type="{ 'is-danger': !!passInvalidMessage }"
                                :message="passInvalidMessage"
                            >
                                <b-input
                                    required
                                    ref="password"
                                    type="password"
                                    pattern="[A-za-z0-9 !@#\$%\^&\*\(\)\-=\[\].,:;<>?]+"
                                    minlength="8"
                                    validation-message="Passwords need to be at least 8 characters long"
                                    v-model="password"
                                    password-reveal
                                    @focus="hasTouchedPassword = true"
                                ></b-input>
                            </b-field>
                            <b-field
                                label="Confirm Password"
                                :type="{ 'is-danger': !!passInvalidMessage }"
                                :message="passInvalidMessage"
                            >
                                <b-input
                                    required
                                    ref="confirmPassword"
                                    type="password"
                                    minlength="8"
                                    pattern="[A-za-z0-9 !@#\$%\^&\*\(\)\-=\[\].,:;<>?]+"
                                    validation-message="Passwords need to be at least 8 characters long"
                                    v-model="confirmPassword"
                                    password-reveal
                                    @focus="hasTouchedPassword = true"
                                ></b-input>
                            </b-field>
                            <b-field label="GitHub username (optional)">
                                <b-input
                                    ref="github"
                                    v-model="github"
                                    pattern="[a-zA-Z0-9\-]*"
                                    maxlength="40"
                                    validation-message="Username may only consist of letters and numbers and hyphens"
                                ></b-input>
                            </b-field>
                            <b-field label="LinkedIn profile URL (optional)">
                                <b-input ref="linkedin" v-model="linkedin" pattern="[a-zA-Z0-9_\-:/.]*"></b-input>
                            </b-field>
                            <b-field label="Personal website (optional)">
                                <b-input
                                    ref="website"
                                    v-model="website"
                                    pattern="[a-zA-Z0-9_\-:/.]*"
                                ></b-input>
                            </b-field>
                        </form>
                    </div>
                    <h4 class="title has-text-centered">Teams</h4>
                    <div class="box">
                        <p>
                            Once you join or create a team, you won't be able to change your team later.
                        </p>
                        <div v-if="!isJoiningTeam">
                            <b-field grouped label="JOIN TEAM BY CODE">
                                <b-input 
                                    placeholder="Team code"
                                    v-model="teamCode"
                                    ref="teamCode"
                                    @input="
                                    (v) => {
                                        teamCode = v.toUpperCase();
                                    }
                                    "
                                    pattern="[A-Z0-9]*"
                                    validation-message="Team code may only consist of uppercase letters and numbers"
                                ></b-input>
                                <p class="control">
                                    <b-button class="button is-primary" @click="checkJoinCode">Join</b-button>
                                </p>
                            </b-field>
                            <br>
                            <b-field label="CREATE A TEAM">
                                <b-input 
                                    placeholder="Team name" 
                                    ref="newTeamName"
                                    v-model="newTeamName"
                                    pattern="[a-zA-Z0-9 ]*"
                                    maxlength="40"
                                    :has-counter="false"
                                    validation-message="Team name may only consist of letters and numbers"
                                ></b-input>
                            </b-field>
                            <b-field label="League" custom-class="sublabel">
                                <b-select
                                    v-model="newTeamCountry">
                                    <option
                                        v-for="country in countries"
                                        :key="country.id"
                                        :value="country.id"
                                    >
                                        {{ country.name }}
                                    </option>
                                </b-select>
                            </b-field>
                            <b-field label="Choose team emoji" custom-class="sublabel">
                                <p class="block team-emojis">{{ teamEmoji }}</p>
                            </b-field>
                            <b-field>
                                <emoji-picker @emoji="selectEmoji" :search='emojiSearch'>
                                    <template v-slot:emoji-invoker="{ events: { click: clickEvent } }">
                                    <b-button
                                        class="button is-primary is-light emoji-invoker"
                                        @click.stop="clickEvent"
                                    >Show emoji picker</b-button>
                                    </template>
                                    <template v-slot:emoji-picker="{ emojis, insert }">
                                        <div class="emoji-picker">
                                            <div class="emoji-picker__search">
                                                <input type="text" v-model="emojiSearch">
                                            </div>
                                            <div>
                                                <div v-for="(emojiGroup, category) in emojis" :key="category">
                                                    <h5>{{ category }}</h5>
                                                    <div class="emojis">
                                                        <span
                                                            v-for="(emoji, emojiName) in emojiGroup"
                                                            :key="emojiName"
                                                            @click="insert(emoji)"
                                                            :title="emojiName"
                                                        >{{ emoji }}</span>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </template>
                                </emoji-picker>
                                <b-button class="button is-danger is-light" @click="teamEmoji = ''">Clear selection</b-button>
                            </b-field>
                            <b-field>
                                <b-button class="button is-primary" @click="checkCreateTeam">Check new team name availability</b-button>
                            </b-field>
                        </div>
                        <div v-else>
                            <p class="block">
                                You're about to join or create the team "{{ joinTeamName }}".
                            </p>
                            <b-field class="block">
                                <b-button class="button is-danger is-light" @click="cancelJoinTeam">Cancel</b-button>
                            </b-field>
                        </div>
                    </div>
                    <vue-recaptcha
                        :sitekey="recaptchaKey"
                        @verify="recaptcha('verify', $event)"
                        @expired="recaptcha('expired', null)"
                        @error="recaptcha('error', null)"
                        ref="recaptcha"
                        size="invisible"
                    >
                    </vue-recaptcha>
                    <p class="has-text-grey has-text-centered block">
                        By clicking the Register button below, you and your team
                        agree to the <a class="has-text-link" href="https://www.labhack.org/t&c/">Terms and Conditions</a> of the SSAI Capture
                        the Flag competition.
                    </p>
                    <b-button type="is-primary" @click="confirmRegister" expanded>Register</b-button>
                    <br>
                    <p class="has-text-grey has-text-centered">
                        <router-link to="/login">Already have an account?</router-link>
                    </p>
                    <p class="has-text-grey has-text-centered">
                        <a href="mailto:bob.lee@wbi-innovates.com">Having trouble registering?</a>
                    </p>
                </div>
            </div>
        </div>
        <b-modal v-model="isRegisterWaitingModalActive" :width="640" :can-cancel="false">
            <div class="card">
                <div class="card-content">
                    <p class="block">Please wait...</p>
                    <b-progress></b-progress>
                </div>
            </div>
        </b-modal>
    </section>
</template>

<script>
 import EmojiPicker from 'vue-emoji-picker'
 import VueRecaptcha from 'vue-recaptcha'
 import isEmail from 'validator/lib/isEmail'
 import isURL from 'validator/lib/isURL'
 export default {
     name: 'Register',
     components: { 'emoji-picker': EmojiPicker, 'vue-recaptcha': VueRecaptcha },
     computed: {
         passInvalidMessage() {
             if (!this.hasTouchedPassword) {
                 return null
             }
             if (!this.password || !this.confirmPassword) {
                 return "Password is required"
             }
             if (this.password !== this.confirmPassword) {
                 return "Passwords must match"
             }
             if (this.password.length < 8 || this.confirmPassword.length < 8) {
                 return "Passwords must be at least 8 characters long"
             }
             if (this.password.match(/[^A-za-z0-9 !@#$%^&*()\-=[\].,:;<>?]/) || this.confirmPassword.match(/^[^A-za-z0-9 !@#$%^&*()\-=[\].,:;<>?]/)) {
                 return "Invalid characters in password"
             }
             return null
         }
     },
     data() {
         return {
             first_name: '',
             middle_name: '',
             last_name: '',
             phone_number: '',
             email: '',
             username: '',
             password: '',
             confirmPassword: '',
             github: '',
             linkedin: '',
             website: '',
             teamCode: '',  // v-model for the join team by code input
             // variables for creating a team
             newTeamName: '',
             newTeamCountry: 1,  // country id
             // variables for the team the user's about to join or create
             joinTeamCode: '',  // the team code of the team that the user will join or create
             joinTeamName: '',
             isJoiningTeam: false,
             teamEmoji: '',
             emojiSearch: '',
             recaptchaKey: process.env.VUE_APP_RECAPTCHA_SITE_KEY,
             countries: [],  // array of objects
             hasTouchedPassword: false,
             isRegisterWaitingModalActive: false
         }
     },
     methods: {
         recaptcha(event, token) {
             if (event === 'verify') {
                 this.$refs.recaptcha.reset()
                 this.register(token)
             } else if (event === 'expired') {
                 this.$refs.recaptcha.reset()
             } else if (event === 'error') {
                 this.toastFivehundred()
                 this.$refs.recaptcha.reset()
             } else if (event === 'execute') {
                 this.$refs.recaptcha.execute()
             }
         },
         validateData() {
             let fields = [
                 'first_name',
                 'middle_name',
                 'last_name',
                 'phone_number',
                 'email',
                 'username',
                 'password',
                 'confirmPassword',
                 'github',
                 'linkedin',
                 'website'
             ]
             for (let i=0; i<fields.length; i++) {
                 // check simple html5 validity (this checks the pattern attribute)
                 if (!this.$refs[fields[i]].checkHtml5Validity()) {
                     return `Validation error in ${fields[i]}`
                 }
             }
             // now we replicate the backend logic --- lots of overlap with the previous check
             let nameRegex = /[^A-zÀ-ÖØ-öø-įĴ-őŔ-žǍ-ǰǴ-ǵǸ-țȞ-ȟȤ-ȳɃɆ-ɏḀ-ẞƀ-ƓƗ-ƚƝ-ơƤ-ƥƫ-ưƲ-ƶẠ-ỿ'\- ]/;
             if (!this.username || this.username.match(/[^a-zA-Z0-9]/) || this.username.length > 20) {
                 return "Validation error in username";
             }
             if (!this.first_name || this.first_name.match(nameRegex)) {
                 return "Validation error in first name";
             }
             if (this.middle_name) {
                 if (this.middle_name.match(nameRegex)) {
                     return "Validation error in midlde name";
                 }
             }
             if (!this.last_name || this.last_name.match(nameRegex)) {
                 return "Validation error in last name";
             }
             if (!this.email || !isEmail(this.email)) {
                 return "Validation error in email";
             }
             if (this.github) {
                 if (this.github.match(/[^a-zA-Z0-9-]/)) {
                     return "Validation error in Github username";
                 }
             }
             if (this.linkedin) {
                 if (!isURL(this.linkedin)) {
                     return "Validation error in LinkedIn URL";
                 }
             }
             if (this.website) {
                 if (!isURL(this.website)) {
                     return "Validation error in personal website URL";
                 }
             }
             if (!this.phone_number || this.phone_number.match(/[^0-9+ \- ()]/) || this.phone_number.length > 19 || this.phone_number.length < 10) {
                 return "Validation error in phone number";
             }
             // finally, check password (returns null if password is ok)
             return this.passInvalidMessage;
         },
         checkJoinCode() {
             // return true if there's a team with code this.teamCode, false otherwise
             this.isJoiningTeam = false
             this.joinTeamName = ''
             this.newTeamName = ''
             if (!this.teamCode || !this.$refs.teamCode.checkHtml5Validity()) {
                 this.$buefy.toast.open({
                     duration: 3000,
                     message: 'Enter a valid team code',
                     position: 'is-bottom',
                     type: 'is-danger',
                     queue: false
                 })
                 return false
             }
             fetch(`/api/teams/info/team_code/${this.teamCode}`)
                 .then((response) => {
                     if (response.ok) {
                         response.json().then((res) => {
                             this.joinTeamName = res.name
                             this.joinTeamCode = res.team_code
                             this.isJoiningTeam = true
                             return true
                         })
                     } else {
                         if (response.status === 404) {
                             this.$buefy.toast.open({
                                 duration: 3000,
                                 message: 'No team with that code found',
                                 position: 'is-bottom',
                                 type: 'is-danger',
                                 queue: false
                             })
                         } else {
                             this.toastFivehundred()
                         }
                         return false
                     }
                 })
                 .catch(() => {
                     this.toastFivehundred()
                     return false
                 })
         },
         selectEmoji(emoji) {
             if ((this.teamEmoji.length / 2) < 3) {
                 // each emoji is length 2
                 this.teamEmoji += emoji
             }
         },
         checkCreateTeam() {
             // check team name is valid and available
             this.isJoiningTeam = false
             this.joinTeamCode = ''
             this.joinTeamName = ''
             if (!this.newTeamName || !this.$refs.newTeamName.checkHtml5Validity()) {
                 this.$buefy.toast.open({
                     duration: 3000,
                     message: "Please pick a valid team name",
                     position: 'is-bottom',
                     type: 'is-danger',
                     queue: false
                 })
                 return
             }
             fetch(`/api/teams/validate/${this.newTeamName}`)
                 .then((response) => {
                     if (response.ok) {
                         this.$buefy.toast.open({
                             duration: 3000,
                             message: 'Team name available',
                             position: 'is-bottom',
                             type: 'is-success',
                             queue: false
                         })
                         this.joinTeamName = this.newTeamName
                         this.isJoiningTeam = true
                         return true
                     } else {
                         if (response.status === 405) {
                             this.$buefy.toast.open({
                                 duration: 3000,
                                 message: 'That team name is already taken',
                                 position: 'is-bottom',
                                 type: 'is-danger',
                                 queue: false
                             })
                         } else if (response.status === 406) {
                             this.$buefy.toast.open({
                                 duration: 3000,
                                 message: 'That team name is not valid',
                                 position: 'is-bottom',
                                 type: 'is-danger',
                                 queue: false
                             })
                         } else {
                             this.toastFivehundred()
                         }
                         return false
                     }
                 })
                 .catch(() => {
                     this.toastFivehundred()
                     return false
                 })
         },
         cancelJoinTeam() {
             this.joinTeamCode = ''
             this.joinTeamName = ''
             this.teamCode = ''
             this.newTeamName = ''
             this.newTeamCountry = 1
             this.teamEmoji = ''
             this.isJoiningTeam = false
         },
         confirmRegister() {
             // confirm user's team selection
             if (!this.isJoiningTeam) {
                 this.$buefy.toast.open({
                     duration: 3000,
                     message: "You must join or create a team",
                     position: 'is-bottom',
                     type: 'is-danger',
                     queue: false
                 })
                 return
             } else {
                 let message = this.newTeamName ? `You're about to create the team "${this.newTeamName}".` : `You're about to join the team "${this.joinTeamName}"`
                 message += " Once you register, you won't be able to change your team. Are you sure?"
                 this.$buefy.dialog.confirm({
                     title: "Register",
                     message: message,
                     confirmText: "Register",
                     type: 'is-primary',
                     onConfirm: () => this.recaptcha('execute')
                 })
             }
         },
         register(recaptchaToken) {
             let valErrors = this.validateData()
             if (!valErrors) {
                 this.isRegisterWaitingModalActive = true;
                 fetch('/api/user/register', {
                     method: 'POST',
                     headers: {
                         'Content-Type': 'application/json;charset=utf-8'
                     },
                     body: JSON.stringify({
                         email: this.email,
                         username: this.username,
                         password: this.password,
                         first_name: this.first_name,
                         middle_name: this.middle_name,
                         last_name: this.last_name,
                         github: this.github,
                         linkedin: this.linkedin,
                         website: this.website,
                         phone_number: this.phone_number,
                         recaptchaToken: recaptchaToken
                     })
                 }).then((response) => {
                     if (response.ok) {
                         // user registered
                         if (this.newTeamName) {
                             // create team
                             let form = new FormData()
                             form.append('emoji', this.teamEmoji)
                             form.append('name', this.newTeamName)
                             form.append('country', this.newTeamCountry)
                             fetch('/api/teams/create', {
                                 method: 'POST',
                                 body: form
                             }).then((response) => {
                                 if (response.ok) {
                                     this.toastRegister()
                                 } else {
                                     this.toastFivehundred()
                                 }
                             })
                         } else if (this.teamCode) {
                             // join team
                             fetch('/api/teams/join', {
                                 method: 'POST',
                                 headers: {
                                     'Content-Type': 'application/json;charset=utf-8'
                                 },
                                 body: JSON.stringify({ teamCode: this.teamCode })
                             }).then((response) => {
                                 if (response.ok) {
                                     this.toastRegister()
                                 } else {
                                     this.toastFivehundred()
                                 }
                             }).catch(() => {
                                 this.toastFivehundred()
                             })
                         }
                         // redirect to contestant portal
                         this.$router.push('/contestant-portal')
                     } else {
                         this.$refs.recaptcha.reset()
                         this.isRegisterWaitingModalActive = false;
                         if (response.status === 409) {
                             // username or email conflict
                             this.$buefy.toast.open({
                                 duration: 3000,
                                 message: 'That username, email, or phone number is already in use',
                                 position: 'is-bottom',
                                 type: 'is-danger',
                                 queue: false
                             })
                             return
                         } else if (response.status === 429) {
                             // rate limit hit
                             this.$buefy.toast.open({
                                 duration: 3000,
                                 message: "You've made too many requests. Please try again in an hour",
                                 position: 'is-bottom',
                                 type: 'is-danger',
                                 queue: false
                             })
                             return
                         } else if (response.status === 405) {
                             this.$buefy.toast.open({
                                 duration: 3000,
                                 message: "Backend validation check failed",
                                 position: 'is-bottom',
                                 type: 'is-danger',
                                 queue: false
                             })
                             return
                         }
                         this.toastFivehundred()
                     }
                 })
             } else {
                 this.$refs.recaptcha.reset()
                 this.isRegisterWaitingModalActive = false;
                 this.$buefy.toast.open({
                     duration: 3000,
                     message: valErrors,
                     position: 'is-bottom',
                     type: 'is-danger',
                     queue: false
                 })   
                 return
             }
         },
         getCountries() {
             // get the valid countries
             fetch('/api/user/register/countries')
                 .then((response) => {
                     if (response.ok) {
                         response.json().then(countries => this.countries = countries)
                     } else {
                         this.toastFivehundred()
                     }
                 }).catch((e) => {
                     console.error(e)
                     this.toastFivehundred()
                 })
         },
         toastFivehundred() {
             this.isRegisterWaitingModalActive = false;
             this.$buefy.toast.open({
                 duration: 3000,
                 message: 'Something went wrong',
                 position: 'is-bottom',
                 type: 'is-danger',
                 queue: false
             })
         },
         toastRegister() {
             this.isRegisterWaitingModalActive = false;
             this.$buefy.toast.open({
                 duration: 3000,
                 message: 'Successfully registered',
                 position: 'is-bottom',
                 type: 'is-success',
                 queue: false
             })
         }
     },
     mounted() {
         this.getCountries()
     }
 }
</script>
<style scoped>
 .team-emojis {
     font-size: 2rem;
 }
 .emoji-picker {
     position: absolute;
     z-index: 1;
     border: 1px solid #ccc;
     width: 15rem;
     height: 20rem;
     overflow: scroll;
     padding: 1rem;
     box-sizing: border-box;
     border-radius: 0.5rem;
     background: #fff;
     box-shadow: 1px 1px 8px #c7dbe6;
 }
 .emoji-picker__search {
     display: flex;
 }
 .emoji-picker__search > input {
     flex: 1;
     border-radius: 10rem;
     border: 1px solid #ccc;
     padding: 0.5rem 1rem;
     outline: none;
 }
 .emoji-picker h5 {
     margin-bottom: 0;
     color: #b1b1b1;
     text-transform: uppercase;
     font-size: 0.8rem;
     cursor: default;
 }
 .emoji-picker .emojis {
     display: flex;
     flex-wrap: wrap;
     justify-content: space-between;
     font-size: 1.2rem;
 }
 .emoji-picker .emojis:after {
     content: "";
     flex: auto;
 }
 .emoji-picker .emojis span {
     padding: 0.2rem;
     cursor: pointer;
     border-radius: 5px;
 }
 .emoji-picker .emojis span:hover {
     background: #ececec;
     cursor: pointer;
 }
</style>
